from ldap import LDAPResultCode

class LDAPError(Exception):
	def __init__(self, code=LDAPResultCode.other, message=''):
		self.code = code
		self.message = message

class LDAPOperationsError(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.operationsError, message)

class LDAPProtocolError(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.protocolError, message)

class LDAPInvalidCredentials(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.invalidCredentials, message)

class LDAPInsufficientAccessRights(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.insufficientAccessRights, message)

class LDAPUnwillingToPerform(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.unwillingToPerform, message)

class LDAPAuthMethodNotSupported(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.authMethodNotSupported, message)

class LDAPConfidentialityRequired(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.confidentialityRequired, message)

class LDAPNoSuchObject(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.noSuchObject, message)

class LDAPUnavailableCriticalExtension(LDAPError):
	def __init__(self, message=''):
		super().__init__(LDAPResultCode.unavailableCriticalExtension, message)
